Loading...
Searching...
No Matches
itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage > Class Template Reference

`#include <itkMultiResolutionGaussianSmoothingPyramidImageFilter.h>`

## Detailed Description

template<class TInputImage, class TOutputImage>
class itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >

Framework for creating images in a multi-resolution pyramid.

MultiResolutionGaussianSmoothingPyramidImageFilter creates an image pryamid according to a user defined multi-resolution schedule.

This class inherits from the MultiResolutionPyramidImageFilter. It applies the same smoothing but does NOT do the downsampling.

The multi-resolution schedule is still specified in terms for 'shrink factors' at each multi-resolution level for each dimension (although, actual shrinking is not performed).

A user can either use the default schedules or specify each factor in the schedules directly.

The schedule is stored as an unsigned int matrix. An element of the table can be access via the double bracket notation: table[resLevel][dimension]

For example: 8 4 4 4 4 2

is a schedule for two computation level. In the first (coarest) level the image is reduce by a factor of 8 in the column dimension, factor of 4 in the row dimension and factor of 4 in the slice dimension. In the second level, the image is reduce by a factor of 4 in the column dimension, 4 is the row dimension and 2 in the slice dimension.

The method SetNumberOfLevels() set the number of computation levels in the pyramid. This method will allocate memory for the multi-resolution schedule table. This method generates defaults tables with the starting shrink factor for all dimension set to 2^(NumberOfLevel - 1). All factors are halved for all subsequent levels. For example if the number of levels was set to 4, the default table is:

8 8 8 4 4 4 2 2 2 1 1 1

The user can get a copy of the schedule via GetSchedule() They may make alteration and reset it using SetSchedule().

A user can create a default table by specifying the starting shrink factors via methods SetStartingShrinkFactors() The factors for subsequent level is generated by halving the factor or setting to one, depending on which is larger.

For example, for 4 levels and starting factors of 8,8,4 the default table would be:

8 8 4 4 4 2 2 2 1 1 1 1

When this filter is updated, NumberOfLevels outputs are produced. The N'th output correspond to the N'th level of the pyramid.

To generate each output image, Gaussian smoothing is first performed using a series of RecursiveGaussianImageFilter with standard deviation (shrink factor / 2)*imagespacing. The smoothed images are NOT downsampled, in contrast to the superclass's behaviour.

This class is templated over the input image type and the output image type.

This filter uses multithreaded filters to perform the smoothing.

This filter supports streaming.

Definition at line 123 of file itkMultiResolutionGaussianSmoothingPyramidImageFilter.h.

Inheritance diagram for itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >:
[legend]

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | Pointer = SmartPointer<Self>
using | Self = MultiResolutionGaussianSmoothingPyramidImageFilter
using | Superclass = MultiResolutionPyramidImageFilter<TInputImage, TOutputImage>

## Public Member Functions

void | GenerateInputRequestedRegion () override
void | GenerateOutputInformation () override
void | GenerateOutputRequestedRegion (DataObject *output) override
virtual const char * | GetClassName () const
| ITK_DISALLOW_COPY_AND_MOVE (MultiResolutionGaussianSmoothingPyramidImageFilter)
| itkStaticConstMacro (ImageDimension, unsigned int, TInputImage::ImageDimension)
| itkStaticConstMacro (OutputImageDimension, unsigned int, TOutputImage::ImageDimension)
void | SetSchedule (const ScheduleType &schedule) override

## Static Public Member Functions

static Pointer | New ()

## Protected Member Functions

void | EnlargeOutputRequestedRegion (DataObject *output) override
void | GenerateData () override
| MultiResolutionGaussianSmoothingPyramidImageFilter ()=default
| ~MultiResolutionGaussianSmoothingPyramidImageFilter () override=default

## Member Typedef Documentation

## ConstPointer

template<class TInputImage, class TOutputImage>

using itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::ConstPointer = SmartPointer<const Self>

Definition at line 133 of file itkMultiResolutionGaussianSmoothingPyramidImageFilter.h.

## Pointer

template<class TInputImage, class TOutputImage>

using itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::Pointer = SmartPointer<Self>

Definition at line 132 of file itkMultiResolutionGaussianSmoothingPyramidImageFilter.h.

## Self

template<class TInputImage, class TOutputImage>

using itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::Self = MultiResolutionGaussianSmoothingPyramidImageFilter

Standard class typedefs.

Definition at line 130 of file itkMultiResolutionGaussianSmoothingPyramidImageFilter.h.

## Superclass

template<class TInputImage, class TOutputImage>

using itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::Superclass = MultiResolutionPyramidImageFilter<TInputImage, TOutputImage>

Definition at line 131 of file itkMultiResolutionGaussianSmoothingPyramidImageFilter.h.

## Constructor & Destructor Documentation

## MultiResolutionGaussianSmoothingPyramidImageFilter()

template<class TInputImage, class TOutputImage>

itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::MultiResolutionGaussianSmoothingPyramidImageFilter | ( |  | ) |

protected default

## ~MultiResolutionGaussianSmoothingPyramidImageFilter()

template<class TInputImage, class TOutputImage>

itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::~MultiResolutionGaussianSmoothingPyramidImageFilter | ( |  | ) |

override protected default

## Member Function Documentation

## EnlargeOutputRequestedRegion()

template<class TInputImage, class TOutputImage>

void itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::EnlargeOutputRequestedRegion | ( | DataObject * | output | ) |

override protected

This filter by default generates the largest possible region, because it uses internally a filter that does this.

## GenerateData()

template<class TInputImage, class TOutputImage>

void itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::GenerateData | ( |  | ) |

override protected

Generate the output data.

## GenerateInputRequestedRegion()

template<class TInputImage, class TOutputImage>

void itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::GenerateInputRequestedRegion | ( |  | ) |

override

MultiResolutionGaussianSmoothingPyramidImageFilter requires a larger input requested region than the output requested regions to accomdate the smoothing operations. As such, MultiResolutionGaussianSmoothingPyramidImageFilter needs to provide an implementation for GenerateInputRequestedRegion(). The original documentation of this method is below.

See also
  ProcessObject::GenerateInputRequestedRegion()

## GenerateOutputInformation()

template<class TInputImage, class TOutputImage>

void itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::GenerateOutputInformation | ( |  | ) |

override

Set spacing etc.

## GenerateOutputRequestedRegion()

template<class TInputImage, class TOutputImage>

void itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::GenerateOutputRequestedRegion | ( | DataObject * | output | ) |

override

Given one output whose requested region has been set, this method sets the requested region for the remaining output images. The original documentation of this method is below.

See also
  ProcessObject::GenerateOutputRequestedRegion();

## GetClassName()

template<class TInputImage, class TOutputImage>

virtual const char * itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented in elastix::FixedSmoothingPyramid< TElastix >, and elastix::MovingSmoothingPyramid< TElastix >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TInputImage, class TOutputImage>

itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::ITK_DISALLOW_COPY_AND_MOVE | ( | MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage > |  | ) |

## itkStaticConstMacro() [1/2]

template<class TInputImage, class TOutputImage>

itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::itkStaticConstMacro | ( | ImageDimension | ,
|  | unsigned int | ,
|  | TInputImage::ImageDimension | )

ImageDimension enumeration.

## itkStaticConstMacro() [2/2]

template<class TInputImage, class TOutputImage>

itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::itkStaticConstMacro | ( | OutputImageDimension | ,
|  | unsigned int | ,
|  | TOutputImage::ImageDimension | )

## New()

template<class TInputImage, class TOutputImage>

Pointer itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::New | ( |  | ) |

static

Method for creation through the object factory.

## SetSchedule()

template<class TInputImage, class TOutputImage>

void itk::MultiResolutionGaussianSmoothingPyramidImageFilter< TInputImage, TOutputImage >::SetSchedule | ( | const ScheduleType & | schedule | ) |

override

Set a multi-resolution schedule. The input schedule must have only ImageDimension number of columns and NumberOfLevels number of rows. In contrast to the superclass, any schedule is allowed:

- For each dimension, the shrink factor may be non-increasing with respect to subsequent levels.
- shrink factors of 0 are allowed. This results in almost no smoothing. Because of lazy programming, the image is then smoothed with a gauss with sigma of 0.01*spacing...

Note that the images are not actually shrunk by this class. They are only smoothed with the same standard deviation gaussian as used by the superclass.

Generated on 1768596610 for elastix by 1.15.0 |